/*
 * Copyright (C) 2023, KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 * Authors: hxf <hewenfei@kylinos.cn>
 */

#ifndef ERNIE_BOT_ERNIE_BOT_H
#define ERNIE_BOT_ERNIE_BOT_H

#include <ukui-menu-interface/menu-extension-iface.h>

class ErnieBotPrivate;

class ErnieBot : public UkuiMenu::MenuExtensionIFace
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID UKUI_MENU_EXTENSION_IFACE_IID FILE "metadata.json")
    Q_INTERFACES(UkuiMenu::MenuExtensionIFace)
public:
    explicit ErnieBot(QObject *parent = nullptr);

    int index() override;
    QString name() override;
    QUrl url() override;
    QVariantMap data() override;
    QVariantList options() override;
    void receive(QVariantMap data) override;

private:
    ErnieBotPrivate *d {nullptr};
};


#endif //ERNIE_BOT_ERNIE_BOT_H
